define([
    "../app/Page",
    "dojo/_base/declare",
    "dojo/_base/event",
    "dojo/_base/lang",
    "require"
], function(Page, declare, event, lang, require) {
    return declare([Page],{
        objectId: null,
        object: null,
        classStore: null,
        constructor: function() {
            if ( !this.classStore ) { throw new Error("Subclasses must specify a classStore."); }
        },
        _load: function() {
            if ( this.object ) {
                this._refresh();
            } else if ( this.objectId ) {
                if ( this.objectId === "new" ) {
                    this.object = this.classStore.create();
                    this._refresh();
                } else {
                    this.classStore.load(this.objectId)
                    .then(lang.hitch(this,'_setObject'),
                          lang.hitch(this,function(err){
                                this.die(err.error);
                            }));
                }
            } else {
                this.die("No valid uid or object passed!");
            }
        },
        _setObject: function(object) {
            this.object = object;
            if ( this.objectId === "new" ) {
                this.go(this.classStore.getObjectPath(this.object),{},true);
            }
            this._refresh();
        },
        _refresh: function() {},
        _save: function() {
            return this.classStore.save(this.object)
            .then(lang.hitch(this,function(object){
                this.markClean();
                this._setObject(object);
                this.notify(this.classStore.getName()+" successfully saved.");
            }),lang.hitch(this,function(e){
                this.notify(e.error,'error');
            }));
        }
    });
});
